package iANT::DB::Feature::Display;

use AnotherTemplate;
use iANT::Feature;
use iANT::Feature::Display;

use iANT::DB::Feature;
use base 'iANT::DB::Feature';

use iANT::Common;
use strict;
use Carp;




sub _Init
{
    my ($self, $source) = @_;
    $self->SUPER::_Init($source);
    $self->{'__template'} = '';
}


sub SetTemplate
{
    my ($self,$template_source) = (@_);

#     confess ("CONDFESS $template_source");
#     $self->Set('template',$template_source);
    $self->{'__template'} = $template_source;
}

sub GetTemplate
{
    my ($self) = (@_);
#    $self->Get('template');
    return $self->{'__template'};
}

sub GetRawTemplate
{
    my ($self) = (@_);
    my $o_AnotherTemplate = New AnotherTemplate();
    $o_AnotherTemplate->Update($self->{'__template'});
    return $o_AnotherTemplate->Get('raw_template');
}


sub Print
{
    my ($self,$entry_file, $method) = (@_);

    my $ra_features = $self->GetFeatures();
    
    my %h_html_display = ();

    foreach my $o_feature (@{$ra_features})
    {
        if (defined $entry_file)
        {
            $o_feature->Set('entry_file',$entry_file);
        }

        my $o_feature_display = New iANT::Feature::Display($o_feature->GetXml());
        my $program_name = $o_feature_display->GetSoftware->GetName();
        my $database_name = $o_feature_display->GetDatabase->GetName();
        $database_name =~ s/.+\///;
        my $key = $database_name.'.'.$program_name;

        if (! defined $h_html_display{$key})
        {
            #$key = $program_name; #exple: GTH
            if (! defined $h_html_display{$database_name.'.'.$program_name})
            {
                $h_html_display{$key} = '';
            }
        }
        $h_html_display{$key} .= $o_feature_display->Print('string');
    }
    
    my $displayed = &OrderedDisplay(\%h_html_display);


    if ($method eq 'string')
    {
        return $displayed;
    }
    else
    {
        print STDOUT $displayed;
    }

    return;
}

sub OrderedDisplay
{
    my $rh_html_display = shift();

    my $o_param = New ParamParser('INIT');
    $o_param = &iANT::Cfg::Load($o_param);
    my @a_merge_order = split (/,/,$o_param->Get('iant_merge_order'));
    my $displayed = '';
    foreach my $merge_order_keyword (@a_merge_order)
    {
        #print STDOUT $rh_html_display->{$merge_order_keyword};
        $displayed .= $rh_html_display->{$merge_order_keyword};
        #print STDERR "1- " . $displayed;
        delete $rh_html_display->{$merge_order_keyword};
    }

    foreach my $remaining_data (keys %{$rh_html_display})
    {
        #print STDOUT $rh_html_display->{$remaining_data};
        $displayed .= $rh_html_display->{$remaining_data};
    }
    return $displayed;
}

1;
