package iANT::Feature::Display;

use AnotherTemplate;
use iANT::Feature;
use base 'iANT::Feature';
use iANT::Common;
use strict;
use Carp;





sub _Init
{
    my ($self, $source) = @_;
    $self->SUPER::_Init($source);
    $self->{'__template'} = '';
}


sub SetTemplate
{
    my ($self,$template_source) = (@_);

#     confess ("CONDFESS $template_source");
#     $self->Set('template',$template_source);
    $self->{'__template'} = $template_source;
}

sub GetTemplate
{
    my ($self) = (@_);
#    $self->Get('template');
    return $self->{'__template'};
}

sub GetRawTemplate
{
    my ($self) = (@_);
    my $o_AnotherTemplate = New AnotherTemplate();
    $o_AnotherTemplate->Update($self->{'__template'});
    return $o_AnotherTemplate->Get('raw_template');
}

sub Print
{
    my ($self, $method) = (@_);
    my $program_name = $self->GetSoftware->GetName();
    my $database_name = $self->GetDatabase->GetName();
    $database_name =~ s/.+\///;
        

    if (! defined $program_name || ($program_name eq ''))
    {
        $program_name = 'generic';
    }

    my $template_param_name = 'tmpl_feature_' . $program_name . $database_name;

    my $o_param = New ParamParser('INIT');
    $o_param = &iANT::Cfg::Load($o_param);
    
    $template_param_name = 'tmpl_feature_' . $program_name if (! $o_param->IsDefined($template_param_name));
    $template_param_name = 'tmpl_feature_generic' if (! $o_param->IsDefined($template_param_name));
    
    my $template = $o_param->Get($template_param_name);
    
    #print STDERR "Template $template_param_name $program_name" . $ENV{IANTCFG} . $template. "\n";
    $self->SetTemplate($template);

#     else
#     {
        my $o_AnotherTemplate = New AnotherTemplate();
        $o_AnotherTemplate->Update($self->GetTemplate());
    
        $o_AnotherTemplate->Set('list_separator',"\t");
        $o_AnotherTemplate->AddObject('feature',$self);
        $o_AnotherTemplate->AddObject('software',$self->GetSoftware);

        my $o_database = $self->GetDatabase;
        $o_database->SetName($database_name);
        $self->SetDatabase($o_database);
        $o_AnotherTemplate->AddObject('database',$o_database);
        my $o_hit = $self->GetHit;

        if ($database_name =~ /sptr/i)
        {
            my $id = $o_hit->GetId();
            $id  =~ s/.+\|//;
            $o_hit->SetId($id);
        }
        elsif ($database_name =~ /prodom/i)
        {
            my $id = $o_hit->GetId();
            if ($o_hit->GetAccession eq '')
            {
                my ($accession) = ($id  =~ /(PD\w+)/);
                $o_hit->SetAccession($accession);
            }
            $o_hit->SetId('');
        }
        $o_AnotherTemplate->AddObject('hit',$o_hit);
        $o_AnotherTemplate->AddObject('sequence',$self->GetSequence);
        $o_AnotherTemplate->AddObject('raw',$o_hit->GetRaw);


        $o_AnotherTemplate->Parse();
        my $parsed_template = $o_AnotherTemplate->Get('parsed_template');
 
        #print STDERR "soft: " . $self->GetSoftware->GetName . "\n";
        #print STDERR "db: " . $self->GetDatabase->GetName . "\n";
        #print STDERR "parsed: " . $parsed_template . "\n";
        if ($method eq 'string')
        {
            return $parsed_template;
        }
        else
        {
            print STDOUT "$parsed_template";
            return;
        }
#     }

}


sub PrintProdomProtein
{
    my ($self) = (@_);
    my $o_hit = $self->GetHit;
    my $id = $o_hit->GetId;
    if ($id =~ /\|/)
    {
        my @a_split = split(/\|/,$id);
        $id = pop(@a_split);
    }
    
    my $first_letter = substr($id,0,1);
    return '<img src="http://prodom.prabi.fr/prodom/2005.1/prodom/' . $first_letter . '/' . $id . '.png" />';

}

sub PrintBlastHit
{
    my ($self) = (@_);
    my $o_sequence = $self->GetSequence;
    my $o_hit = $self->GetHit;
    
    if ($o_sequence->GetStrand eq '-')
    {
        my $tmp = $o_sequence->GetBegin;
        $o_sequence->SetBegin($o_sequence->GetEnd);
        $o_sequence->SetEnd($tmp);
    }

    if ($o_hit->GetStrand eq '-')
    {
        my $tmp = $o_hit->GetBegin;
        $o_hit->SetBegin($o_hit->GetEnd);
        $o_hit->SetEnd($tmp);
    }

    my $o_param = New ParamParser('INIT');
    $o_param = &iANT::Cfg::Load($o_param);
    my $template = $o_param->Get('tmpl_feature_blast_hit');
    my $o_AnotherTemplate = New AnotherTemplate();
    $o_AnotherTemplate->Update($template);

    $o_AnotherTemplate->Set('list_separator',"\t");
    $o_AnotherTemplate->AddObject('sequence',$o_sequence);
    $o_AnotherTemplate->AddObject('hit',$o_hit);
    $o_AnotherTemplate->AddObject('raw',$self->GetHit->GetRaw);


    $o_AnotherTemplate->Parse();
    my $parsed_template = $o_AnotherTemplate->Get('parsed_template');
    $parsed_template =~ s/\n//g;
    return $parsed_template;
}

sub PrintGthHit
{
    my ($self) = (@_);    

    my $entryfile = $self->GetEntryFile;
    return 'no data' if (! defined $entryfile);

    my $o_param = New ParamParser('INIT');
    $o_param = &iANT::Cfg::Load($o_param);
    my $bdbh_bin = $o_param->Get('bdbh');
    my $unix_cat = $o_param->Get('unix_cat');
    my $entry_directory  = dirname($entryfile);
    my $file  = basename($entryfile);

    my ($entry_accession) = ($entry_directory =~ /.+\/(\w+)$/);

    my $bdb_file = "$entry_directory/" . $entry_accession . '.analyses.bdb';
#    $entry_directory/" . $entry_accession .;

    my $gth_filename =  $entry_accession . '.' . $o_param->Get('gth_extension');
   
    my $extract_cmd = '';
    my $extract_file = "/tmp/$$.gth";

    if (-e $bdb_file)
    {
        $extract_cmd = "$bdbh_bin -d $bdb_file cat $file > $extract_file";
    }
    elsif (-e "$entry_directory/$gth_filename")
    {
        $extract_cmd = "$unix_cat $entry_directory/$gth_filename > $extract_file";
        &System("$unix_cat $entry_directory/$gth_filename > /tmp/$$.gth", 'stderr');
    }
    else
    {
        return 'no data';
    }
    &System("$extract_cmd", 'stderr');
    my $hit_accession = $self->GetHit->GetAccession;
    my $xsltproc_bin = $o_param->Get('xsltproc');
    my $gthfeatures2html_stylesheet =  $o_param->Get('gthfeatures2html');
    my $filter_string = " hit/accession = $hit_accession , element != full";
    my $filter_bin = $o_param->Get('iant_filter');

    my $filter_cmd =  $filter_bin 
                                    . " --infile " . $extract_file
                                    . " --outfile stdout"
                                    . " --filter \"". $filter_string . "\"";

    my $css = $o_param->Get('http_root') . '/web/css/iANT.css';
    my $cmd = "$filter_cmd | $xsltproc_bin --stringparam css \"$css\" $gthfeatures2html_stylesheet -";

    my $result = `$cmd`;
    unlink $extract_file;
    return $result;


}

sub PrintGenericHit
{
    my ($self) = (@_);
    my $o_sequence = $self->GetSequence;
    my $o_hit = $self->GetHit;
    
    if ($o_sequence->GetStrand eq '-')
    {
        my $tmp = $o_sequence->GetBegin;
        $o_sequence->SetBegin($o_sequence->GetEnd);
        $o_sequence->SetEnd($tmp);
    }

    if ($o_hit->GetStrand eq '-')
    {
        my $tmp = $o_hit->GetBegin;
        $o_hit->SetBegin($o_hit->GetEnd);
        $o_hit->SetEnd($tmp);
    }

    my $string = '';
    foreach my $o_property (@{$o_hit->GetProperties})
    {
        $string .= $o_property->GetId . '=' . $o_property->GetValue . ' ,';
    }
    chop $string;


    return $string;

}
1;
